#include <stdio.h>
#include <stdlib.h>

#include "bignum.h"
#include "print.h"
void
test_kmul()
{
	struct bignum *a, *b, *c;
					//	1	2	  3	   4	    5	     6		7	  8	   9	    10      11	12	13	  14	    15      16	17     18
	unsigned short av[] = { 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, };
	unsigned short two[] = { 0x0002 };
	unsigned short one[] = { 0x0001 };
	unsigned short bbv[] = { 0x0145 };
	unsigned short aaa[] = { 0xffff, 0xffff };
	unsigned short a3[] = { 0xffff, 0xffff, 0x0000, 0x0000 };

	a = bnum_new();
	b = bnum_new();
	c = bnum_new();

	bnum_set_safe(a, two, 1, 0);
	bnum_set_safe(b, two, 1, 0);
	bnum_kmul(c, a, b);
	printf("0x0002 * 0x0002 = 0x0004\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");

	
	bnum_set_safe(a, one, 1, 0);
	bnum_set_safe(b, aaa, 2, 1);
	bnum_kmul(c, a, b);
	printf("0x0001 * -0xFFFF.FFFF = -0xFFFF.FFFF\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");
	
	
	bnum_set_safe(a, aaa, 2, 1);
	bnum_set_safe(b, aaa, 2, 0);
	bnum_kmul(c, a, b);
	printf("-0xFFFF.FFFF * 0xFFFF.FFFF = -0xFFFF.FFFE.0000.0001\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");
	
	
	bnum_set_safe(a, bbv, 1, 1);
	bnum_set_safe(b, bbv, 1, 1);
	bnum_kmul(c, a, b);
	printf("-0x0145 * -0x0145= 0x0001.9C99\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");
	
	bnum_set_safe(a, a3, 4, 0);
	bnum_set_safe(b, a3, 4, 0);
	bnum_kmul(c, a, b);
	printf("0x0000.0000.FFFF.FFFF * 0x0000.0000.FFFF.FFFF = 0xFFFF.FFFE.0000.0001\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");
	
	bnum_reset(a);
	bnum_reset(b);
	
	bnum_set_safe(a, av, 6, 0);
	bnum_set_safe(b, av, 8, 0);
	bnum_kmul(c, a, b);
	printf("0xFFFF(x6) * 0xFFFF(x8) = ??\nbnum_kmul return:          ");
	bnum_printhex(c);
	printf("\n\n");
	
	bnum_free(&a);
	bnum_free(&b);
	bnum_free(&c);
}

int
main(int argc, char *argv[])
{
	test_kmul();

	return 0;
}
